package it.amattioli.encapsulate.money.specifications;

import it.amattioli.dominate.Entity;
import it.amattioli.dominate.specifications.Assembler;
import it.amattioli.dominate.specifications.hibernate.CriteriaAssembler;

import org.hibernate.Criteria;
import org.hibernate.criterion.Restrictions;

public class CriteriaMoneySpecification<T extends Entity<?>> extends MoneySpecification<T> {

	public CriteriaMoneySpecification(String propertyName) {
		super(propertyName);
	}

	public CriteriaMoneySpecification(String propertyName, MoneySpecification<T> chained) {
		super(propertyName, chained);
	}

	@Override
	public void itselfAssembleQuery(Assembler assembler) {
		addCriteria(((CriteriaAssembler) assembler).assembledCriteria());
	}

	@Override
	public boolean itselfSupportsAssembler(Assembler assembler) {
		return assembler instanceof CriteriaAssembler;
	}
	
	private void addCriteria(Criteria crit) {
        if (wasSet()) {
        	if (getValue().isLowBounded()) {
        		crit.add(Restrictions.ge(getPropertyName()+".value", getValue().getLow().getValue()));
        	}
        	if (getValue().isHighBounded()) {
        		crit.add(Restrictions.lt(getPropertyName()+".value", getValue().getHigh().getValue()));
        	}
        }
    }

}
